pub mod name;
pub mod text;
pub mod binary;
mod rr_type;

pub use self::name::{DnsName, DnsCompressedName};
pub use self::text::{ShortText};
pub use self::binary::{HexShortBlob, Base32ShortBlob, LongText, RemainingText, HexRemainingBlob};
pub use self::rr_type::Type;
