pub extern crate byteorder;
pub extern crate bytes;
#[macro_use]
pub extern crate failure;

#[macro_use]
extern crate dnsbox_derive;
extern crate smallvec;
#[macro_use]
extern crate lazy_static;

#[macro_use]
pub mod errors;
pub mod common_types;
pub mod records;
pub mod ser;

// dnsbox_derive will use ::dnsbox_base::...; make this work in this crate too.
mod dnsbox_base {
	#[allow(unused_imports)]
	pub use super::*;
}
